﻿using Syncfusion.UI.Xaml.Grid;
using Syncfusion.UI.Xaml.Grid.Helpers;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Controls.Primitives;
using System.Windows.Input;
using System.Windows.Interactivity;

namespace SfDataGridDemo
{
    public class SfDataGridBehavior : Behavior<SfDataGrid>
    {
        protected override void OnAttached()
        {
            base.OnAttached();
            this.AssociatedObject.Loaded += AssociatedObject_Loaded;
        }

        private void AssociatedObject_Loaded(object sender, System.Windows.RoutedEventArgs e)
        {
            this.AssociatedObject.GetVisualContainer().ScrollOwner.PreviewMouseLeftButtonDown += ScrollOwner_PreviewMouseLeftButtonDown;
        }

        private void ScrollOwner_PreviewMouseLeftButtonDown(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            RepeatButton repeatButton = null;
            object value = null;
            var source = e.OriginalSource;
            while (repeatButton == null && source != null)
            {
                var parent = source.GetType().GetProperty("InternalVisualParent", BindingFlags.Instance | BindingFlags.NonPublic);
                value = parent.GetValue(source);
                source = value;
                repeatButton = value as RepeatButton;
            }

            if (repeatButton != null)
            {
                var name = ((RoutedCommand)repeatButton.Command).Name;
                if (name == "LineUp" || name=="PageUp")
                {
                    for (int i = 0; i < 10; i++)
                        this.AssociatedObject.GetVisualContainer().LineUp();
                    e.Handled = true;
                }
                else if (name == "LineDown" || name=="PageDown")
                {
                    for (int i = 0; i < 10; i++)
                        this.AssociatedObject.GetVisualContainer().LineDown();
                    e.Handled = true;
                }
            }
        }

        protected override void OnDetaching()
        {
            this.AssociatedObject.GetVisualContainer().ScrollOwner.PreviewMouseLeftButtonDown -= ScrollOwner_PreviewMouseLeftButtonDown;
            this.AssociatedObject.Loaded -= AssociatedObject_Loaded;
            base.OnDetaching();
        }
    }
}
